/*
 * DbgAlloc.hpp
 *
 *  Created on: Oct 26, 2010
 *      Author: kottlers
 */

#ifndef DBGALLOC_HPP_
#define DBGALLOC_HPP_
#include <iostream>

using std::cout; using std::endl;



inline uint64_t usedMemoryBytes(){
	static const int 		pid  = getpid();
	static const uint64_t	page_sz = getpagesize();

    char    path[256];
    sprintf(path, "/proc/%d/statm", pid);
    FILE*   in = fopen(path, "rb");
    if (in == NULL) return 0;
    uint64_t     value;
# if __WORDSIZE == 64
    if(!fscanf(in, "%ld", &value)){value = 0;}
#else
    if(!fscanf(in, "%lld", &value)){value = 0;}
#endif
    fclose(in);
    return value * page_sz;
}



template<class T,char nm>
struct DbgAlloc: public std::allocator<T>{

/*
	typename std::allocator<T>::pointer allocate(typename std::allocator<T>::size_type n, const void* = 0){
		cout << "Before allocation in " << nm <<": " <<  usedMemoryBytes()/MEGA << " MB" << endl;
		//printStackTrace();
		typename std::allocator<T>::pointer ret = std::allocator<T>::allocate(n);
		cout << "After allocation in " << nm <<": " <<  usedMemoryBytes()/MEGA << " MB" << endl;
		return ret;
	 }

	 void deallocate(typename std::allocator<T>::pointer __p, typename std::allocator<T>::size_type x){
		 cout << "Before deletion in " << nm <<": " << usedMemoryBytes()/MEGA << " MB" << endl;
		 std::allocator<T>::deallocate(__p,x);
		 cout << "After deletion in " << nm <<": " <<  usedMemoryBytes()/MEGA << " MB" << endl;
	 }

	 template<typename _Tp1>
	 struct rebind{
		 typedef DbgAlloc<_Tp1,nm> other;
	 };
*/


};

#endif /* DBGALLOC_HPP_ */
